% Example_8_1.m
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Delay and magnitude complementary FIR filters
% Design and properies
close all, clear all
%hmin = firhalfband(9,0.4,'minphase');
%hlp=conv(hmin,fliplr(hmin));
%N=input('order of linear phase filter ')
%delta=input('stopband ripple of linear phase filter ')
Nord = 18;  delta = 0.04; fc = 0.5                               % Setting the input parameters
delp = delta/(2*(1 - delta));                                           % Adjusting the ripple value, Step 1
elp = firceqrip(Nord,fc,[delp,delp]);                             % Design of the intermediate filter Elp(z), Step 2
hlp = (1 - delta)*elp;                                                        % Modifying the intermediate filter Elp(z), Step 3
hlp(Nord/2 + 1) = hlp(Nord/2+1)+delta/2;                     % Modifying the intermediate filter Elp(z), Step 3
hhp=zeros(size(1:length(hlp)));                                  % Zero settings
hhp(10) = 1;  hhp = hhp - hlp;                                     % Complementary highpass filter, Step 4

figure (1)
subplot(2,2,1)
stem((0:18),hlp), xlabel('n'),ylabel('h_L_P[n]')
axis([0,18,-0.4,0.6])

subplot(2,2,2)
%stem((0:18),hhp),xlabel('n'),ylabel('h_H_P[n]')
%axis([0,18,-0.4,0.6])
zplane(hlp,1)
f(1)=0;
omega(1)=pi*f(1);
K=(length(hlp)+1)/2;
n=1:K-1;
h_red=hlp(1:K-1);
h_red=fliplr(h_red);
hh_red=hhp(1:K-1);
hh_red=fliplr(hh_red);
for p=1:101
Alp(p)=1/2+2*sum(h_red.*cos(omega(p)*n));
Ahp(p)=1/2+2*sum(hh_red.*cos(omega(p)*n));
f(p+1)=f(p)+0.01;
omega(p+1)=pi*f(p+1);
end

subplot(2,1,2)
plot(f(1:length(Alp)),Alp,f(1:length(Ahp)),Ahp,'b')
xlabel('Normalized frequency \omega/\pi'),ylabel('Magnitude'),grid
axis([0,1,-0.1,1.1])

