% Example_8_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Power-complementary FIR filters
% Design and properies
close all, clear all
%[hlp,hhp,g0,g1] = firpr2chfb(15,0.4);
%hlp = firhalfband(15,0.4,'minphase');
%N=input('order of linear phase filter ')
%delta=input('stopband ripple of linear phase filter ')
Nord = 15; Nord = 2*Nord;  delta = 0.1;                           % Setting the input papameters
dfir =(delta^2)/(2*(1 - (delta^2)));                                      % Adjusting the ripple value, Substep 1.1
elp = firceqrip(Nord,0.5,[dfir,dfir]);                                    % Design of the intermediate filter Elp(z), Substep 1.2
eh = (1-(delta^2))* elp;                                                      % Modifying the intermediate filter Elp(z), Substep 1.3
eh(Nord/2+1) = eh(Nord/2 + 1) + (delta^2)/2;                   % Modifying the intermediate filter Elp(z), Substep 1.3          
[hlp,ssp,iter] = minphase(eh(Nord/2 + 1:Nord+1));           % Generating the minimum-phase lowpass filter Hlp(z), Step 2
n = 0:length(hlp) - 1;                                                          % Indexing the filter coefficients
hhp = fliplr(hlp).*((-1).^n);                                                   % Complementary highpass filter, Step 3
figure (1)
subplot(2,2,1)
stem((0:15),hlp), xlabel('n'),ylabel('h_L_P[n]')
axis([0,15,-0.5,0.6])
%hhp=zeros(size(1:length(hlp)));
%hhp(10) = 1;
%hhp = hhp - hlp;
subplot(2,2,2)
stem((0:15),hhp),xlabel('n'),ylabel('h_H_P[n]')
axis([0,15,-0.5,0.6])
% figure (1)
subplot(2,2,3)
zplane(hlp,1)
subplot(2,2,4)
zplane(hhp,1)
figure (2)
[Hlp,f]=freqz(hlp,1,512,2);
[Hhp,f]=freqz(hhp,1,512,2);
% subplot(2,1,2)
plot(f,abs(Hlp),f,abs(Hhp),'b')
xlabel('Normalized frequency \omega/\pi'),ylabel('Magnitude'),grid
axis([0,1,-0.1,1.1])

g(1)=axes('Position',[0.20 0.70 0.25 0.1]);
plot(f(1:222),(abs(Hlp(1:222)))), axis([0,0.45,0.99,1.002]),grid

g(2)=axes('Position',[0.62 0.70 0.25 0.1]);
plot(f(285:512),(abs(Hhp(285:512)))), axis([0.55,1,0.99,1.002]),grid
%axis([0 1.1*fp/2 -2*Rp 2*Rp]), grid