% Example_8_3
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% IIR complementary filter pair
 close all, clear all
% Allpass branches
N = 5;   fp = 0.4;                                                                    % Setting input parameters for lowpass filter
[b,a,z,p,k] = halfbandiir(N,fp);                                                % Lowpass halfband filter design
pabs = sort(abs(p));                                                               % Order of the filter poles
beta0 = (abs(pabs(2)))^2;    beta1=(abs(pabs(4)))^2;            % Coefficients of allpass branches
[A0,f] = freqz([beta0,0,1],[1,0,beta0],512,2);                           % Frequency response of A0(z)
[A1,f] = freqz([0,beta1,0,1],[1,0,beta1],512,2);                        % Frequency response of A1(z)
GLp = (A0 + A1)/2;                                                                  % Lowpass filter frequency response
GHp = (A0 - A1)/2;                                                                  % Highpass filter frequency response
figure (1)
%subplot(4,1,1)
plot(f,(abs(GLp)),f,abs(GHp),'b')
text(0.33,-10,'Filter characteristic')
xlabel ('Normalized frequency \omega/\pi'),ylabel('Magnitude'), grid, axis([0,1,0,1.05])
 
g(1)=axes('Position',[0.24 0.70 0.25 0.1]);
plot(f(1:205),(abs(GLp(1:205)))), axis([0,0.4,0.9998,1.00002])

g(2)=axes('Position',[0.62 0.70 0.25 0.1]);
plot(f(307:512),(abs(GHp(307:512)))), axis([0.6,1,0.9998,1.00002])
