% Example_8_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Power-complementary filters of Class II
% Design and properies
close all, clear all
%[hlp,hhp,g0,g1] = firpr2chfb(15,0.4);
%hlp = firhalfband(15,0.4,'minphase');
%N=input('order of linear phase filter ')
%delta=input('stopband ripple of linear phase filter ')
Nord = 5; Nord = 2*Nord;
delta = 0.001
dfir =(delta^2)/(2*(1-(delta^2)));
hl = firceqrip(Nord,0.5,[dfir,dfir]); %fvtool(hl)
eh = (1-(delta^2))*hl;
eh(Nord/2+1) = eh(Nord/2+1)+(delta^2)/2; %fvtool(eh)
[alp,ssp,iter] = minphase(eh(Nord/2+1:Nord+1)); %fvtool(h)
n = 0:length(alp)-1;
ahp = fliplr(alp).*((-1).^n);
len = Nord/2
figure (1)
subplot(2,2,1)
stem((0:len),alp), xlabel('n'),ylabel('a_L_P[n]')
axis([0,len,-0.5,0.6])
%hhp=zeros(size(1:length(hlp)));
%hhp(10) = 1;
%hhp = hhp - hlp;
subplot(2,2,2)
stem((0:len),ahp),xlabel('n'),ylabel('a_H_P[n]')
axis([0,len,-0.5,0.6])
% figure (1)
subplot(2,2,3)
zplane(alp,1)
subplot(2,2,4)
zplane(ahp,1)
figure (2)
[Hlp,f]=freqz(alp,1,512,2);
[Hhp,f]=freqz(ahp,1,512,2);
% subplot(2,1,2)
plot(f,20*log10(abs(Hlp)),f,20*log10(abs(Hhp)),'b')
xlabel('\omega/\pi'),xlabel('\theta/\pi'),ylabel('Gain [dB]'),grid
axis([0,1,-80,2])

%g(1)=axes('Position',[0.20 0.70 0.25 0.1]);
%plot(f(1:222),(abs(Hlp(1:222)))), axis([0,0.45,0.99,1.002]),grid

%g(2)=axes('Position',[0.62 0.70 0.25 0.1]);
%plot(f(285:512),(abs(Hhp(285:512)))), axis([0.55,1,0.99,1.002]),grid
%axis([0 1.1*fp/2 -2*Rp 2*Rp]), grid
beta = 0.545577589;
Aa0 = [1,0,beta];
Ab0 = fliplr(Aa0);
Ab1 = [0,1];
Aa1 = 1;
[H0,f] = freqz(Ab0,Aa0,512,2);
[H1,f] = freqz(Ab1,Aa1,512,2);
Hiil=(H0+H1);
Hiih=(H0-H1);
figure (3)
subplot(5,1,1:2)
plot(f,20*log10(abs(Hiil/2)),f,20*log10(abs(Hiih/2)),'b'),grid
xlabel('\omega/\pi'),ylabel('Gain [dB]')
axis([0,1,-30,2])
a = alp;

% Lattice structure of the 5th order minimum phase halfband FIR filter
a5=a/a(1);
b5=a5;
b5(1:2:6)=-a5(1:2:6);
b5=fliplr(b5);
k5=a5(6);
a3=(a5+k5*b5)/(1+k5^2);
a3=a3(1:4);
b3=(b5-k5*a5)/(1+k5^2);
b3=b3(3:6);
k3=a3(4);
a1=(a3+k3*b3)/(1+k3^2);
a1=a1(1:2);
b1=(b3-k3*a3)/(1+k3^2);
b1=b1(3:4);
k1=a1(2);

disp('=================================================')
disp([sprintf(' lattice coefficient k1 = %15.9f', k1)])
disp([sprintf(' lattice coefficient k3 = %15.9f', k3)])
disp([sprintf(' lattice coefficient k5 = %15.9f', k5)])
disp('=================================================')

u=zeros(size(1:1024));
u(1)=1;
v1=[0,1];
v2=[0,0,1];
x1=u-k1*filter(v1,1,u);
y1=k1*u+filter(v1,1,u);
x3=x1-k3*filter(v2,1,y1);
y3=k3*x1+filter(v2,1,y1);
x5=x3-k5*filter(v2,1,y3);
y5=k5*x3+filter(v2,1,y3);
[H0,w]=freqz(x5,1,4096);
%figure (5)
%plot(w/(2*pi),-20*log10(abs(H0)))
%hold on
%figure (5)
%[H1,w]=freqz(y5,1,4096);
%plot(w/(2*pi),-20*log10(abs(H1)),'r')
%xlabel('Normalized frequency')
%ylabel('Attenuation')
%title('FIR prototype: complementary filters')
  
Q=[beta,0,1];
P=fliplr(Q);
QQ=conv(Q,Q);
PP=conv(P,P);

x1=filter(Q,P,u)-k1*filter(v1,1,u);
y1=k1*filter(Q,P,u)+filter(v1,1,u);
x3=filter(QQ,PP,x1)-k3*filter(v2,1,y1);
y3=k3*filter(QQ,PP,x1)+filter(v2,1,y1);
x5=filter(QQ,PP,x3)-k5*filter(v2,1,y3);
y5=k5*filter(QQ,PP,x3)+filter(v2,1,y3);
[H0,w]=freqz(x5,1,4096);
dop=20*log10(max(abs(H0)));
figure (4)
plot(w/(pi),20*log10(abs(H0))-dop)
hold on
[H1,w]=freqz(y5,1,4096);
figure (4)
plot(w/(pi),20*log10(abs(H1))-dop,'b'), grid
xlabel('\omega/\pi'),ylabel('Gain [dB]')
axis([0,1,-80,2])
% xlabel('Normalized frequency')
% ylabel('Attenuation')
% title('Halfband complementary filters')
%figure(9)
%subplot(2,1,1)
%stem((0:50),x5(1:51))
%subplot(2,1,2)
%stem((0:50),y5(1:51))



