% figure8_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Complementary IIR highpass filter
close all, clear all
[blp,alp]=cheby1(7,.5,.4);
[bhp,ahp]=iirpowcomp(blp,alp);
figure (1)
subplot(2,2,1)
impz(blp,alp,26), title(' '),ylabel('h_L_P[n]')
subplot(2,2,2)
impz(bhp,ahp,26), title(' '),ylabel('h_H_P[n]')
axis([0,25,-0.6,0.6])
subplot(2,2,3)
[Hlp,f]=freqz(blp,alp,512,2);
plot(f,(abs(Hlp)).^2), xlabel('\omega/\pi'),ylabel('|H_L_P|^2')
axis([0,1,0,1])
subplot(2,2,4)
[Hhp,f]=freqz(bhp,ahp,512,2);
plot(f,(abs(Hhp)).^2), xlabel('\omega/\pi'),ylabel('|H_H_P|^2')
axis([0,1,0,1])