% figure_8_8
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Delay complementary FIR filters
% Design and properies
close all, clear all
hlp = firhalfband(14,0.4)
figure (1)
subplot(2,2,1)
stem((0:14),hlp), xlabel('n'),ylabel('h_L_P[n]')
axis([0,14,-0.4,0.6])
hhp=zeros(size(1:length(hlp)));
hhp(8) = 1;
hhp = hhp - hlp;
subplot(2,2,2)
stem((0:14),hhp),xlabel('n'),ylabel('h_H_P[n]')
axis([0,14,-0.4,0.6])
f(1)=0
omega(1)=pi*f(1);
K=(length(hlp)+1)/2;
n=1:K-1;
h_red=hlp(1:K-1);
h_red=fliplr(h_red);
hh_red=hhp(1:K-1);
hh_red=fliplr(hh_red);
for p=1:101
Alp(p)=1/2+2*sum(h_red.*cos(omega(p)*n));
Ahp(p)=1/2+2*sum(hh_red.*cos(omega(p)*n));
f(p+1)=f(p)+0.01;
omega(p+1)=pi*f(p+1);
end

subplot(2,1,2)
plot(f(1:length(Alp)),Alp,f(1:length(Ahp)),Ahp,'b')
xlabel('Normalized frequencies \omega/\pi'),ylabel('Amplitude'),grid
axis([0,1,-0.1,1.1])

